# Cone
Cone is a very simple syntax highlighter and code editor, written in JavaScript.
To start, open the command line in your project and write:
```
npm install cone-editor
```
This will install Cone in your project. To use it in your project, type the following in your index.html:
``` html
<script src="./node_modules/cone-editor/cone.js"></script>
```
or
``` html
<script src="./node_modules/cone-editor/cone.min.js"></script>
```
If you're using JSX or TSX, you can import it using the `import` statement:
``` js
import "./node_modules/cone-editor/cone.js"
```
or
``` js
import "./node_modules/cone-editor/cone.min.js"
```
To actually use it, create a div:
``` html
<div id="myEditor"></div>
```
Then, in your JavaScript, write:
``` js
cone.editor.init(document.getElementById("myEditor"), "html", "&lt;p&gt;My first editor!&lt;/p&gt;", cone.defaultTheme);
```
Congratulations! You just made your first editor!
If the text is offsetted from the selection, set the last argument to true:
``` js
cone.editor.init(document.getElementById("myEditor"), "html", "&lt;p&gt;My first editor!&lt;/p&gt;", cone.defaultTheme, true);
```
To get some help, run: 
```
cd node_modules/cone-editor && npm run help
```
If you don't have Node.js, you can [click me](https://drive.google.com/file/d/16yrGhFhnMBp8cnKL486W1oxyeKKXtyoj/view?usp=drive_link) and click download on the page that shows up. To use it, in this case, write:
``` html
<script src="cone.min.js"></script>
```
If it is in a folder in the same directory, write the folder name between `./` and `/`:
``` html
<script src="./foldername/cone.min.js"></script>
```
If it is at the root of the drive, add a slash:
``` html
<script src="/cone.min.js"></script>
```
If it is in a folder at the root of the drive, write the folder name between slashes:
``` html
<script src="/foldername/cone.min.js"></script>
```
To just syntax highlight an element, make a pre element:
``` html
<pre id="myPre">&lt;p&gt;My first code!&lt;/p&gt;</pre>
```
Then write this in your scripts:
``` js
cone.syntaxHighlight(document.getElementById("myPre"), "html");
```
## Editor
### Known bugs
- If you delete all text in the editor, you can't type in the editor anymore.
### Features
- Syntax highlighting
- Tab handling as whitespace
### Supported languages
- HTML
- CSS
- JS
- XML (in code SGML)
- Plaintext